<template lang="pug">
  div.sigma.statistics
    div.ui.container
      div.sigma.header.centered
        h1 Statistics
        p.subtitle The numbers, what do they mean!?
      div.sigma.statistics.wrapper.ui.segment.inverted(v-if="loading")
        div.ui.active.inline.text.loader.inverted.centered.sigma-stats-loader(v-if="loading") Loading...
      div.ui.inverted.segment(v-else-if="errored")
        i.warning.icon
        | Failed to retrieve the stats...
      div.sigma.statistics.wrapper.ui.segment.inverted(v-else)
        div.sigma.statistics.category.ui.segment.inverted(v-for="cat in stats")
          h2(v-on:click="cat.active = !cat.active") #[i(:class="cat.active ? 'angle up icon' : 'angle down icon'")] {{ cat.name }}
          div.ui.comments.inverted(v-if="cat.active")
            div.ui.comment.inverted(v-for="stat in cat.stats")
              div.content.ui.segment.inverted.stacked {{ stat.name }}: #[span.stat.number {{ numberWithCommas(stat.value) }}]
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'

import LuciaCoreGQL from '@/data/gql'

const gql = new LuciaCoreGQL()

export interface StatisticsItem {
  name: string,
  count: number
}

export interface FullGQLStats {
  sigma: {
    stats: {
      commands: StatisticsItem[],
      events: StatisticsItem[],
      special: StatisticsItem[],
      commandCount: number,
      guildCount: number,
      channelCount: number,
      memberCount: number
    }
  }
}

export interface StatisticsRecord {
  key: string,
  name: string,
  value: number
}

interface StatisticsSegment {
  name: string,
  stats: StatisticsRecord[],
  active: boolean
}

interface SegmentItem {
  name: string,
  raw: StatisticsItem[]
}

function updateStatistics (ctx: SigmaStats) {
  ctx.loading = true
  const qry = `{
    sigma {
      stats {
        commands {
          name
          count
        }
        events {
          name
          count
        }
        special {
          name
          count
        }
        commandCount
        guildCount
        channelCount
        memberCount
      }
    }
  }`
  const req: Promise<FullGQLStats> = gql.request(qry)
  req.then((data: FullGQLStats) => {
    const deep = data.sigma.stats
    const segments: SegmentItem[] = [
      {
        name: 'Population',
        raw: [
          { name: 'guildCount', count: deep.guildCount } as StatisticsItem,
          { name: 'channelCount', count: deep.channelCount } as StatisticsItem,
          { name: 'memberCount', count: deep.memberCount } as StatisticsItem
        ]
      },
      {
        name: 'Commands',
        raw: deep.commands
      },
      {
        name: 'Events',
        raw: deep.events
      },
      {
        name: 'Special',
        raw: deep.special
      }
    ]
    segments.forEach((segment: SegmentItem) => {
      const reprocessedRecords: StatisticsRecord[] = []
      segment.raw.forEach((elem: StatisticsItem) => {
        const recordNew: StatisticsRecord = { key: elem.name, name: elem.name.toUpperCase(), value: elem.count }
        reprocessedRecords.push(recordNew)
      })
      reprocessedRecords.sort((a, b) => { return a.name.localeCompare(b.name) })
      ctx.stats.push({
        name: segment.name,
        stats: reprocessedRecords,
        active: false
      })
    })
    ctx.loading = false
    ctx.errored = false
  })
  req.catch(() => {
    ctx.loading = false
    ctx.errored = true
  })
}

@Component
export default class SigmaStats extends Vue {
  loading = true
  errored = false
  stats: StatisticsSegment[] = []
  mounted () {
    updateStatistics(this)
  }
  numberWithCommas (x: number) {
    let y = x.toString()
    var pattern = /(-?\d+)(\d{3})/
    while (pattern.test(y)) {
      y = y.replace(pattern, '$1,$2')
    }
    return y
  }
}
</script>

<style lang="stylus" scoped>
.sigma.statistics.category
  & h2
    font-size: 1.25rem
    padding: unset
    margin: unset
    cursor pointer
.stat.number
  font-weight: 700
</style>
